## netconsd 0.4.1

=== Makefile ===
CC ?= gcc

LIBS = -lpthread -lrt -ldl
CFLAGS ?= -O2 -fPIC
CFLAGS += -D_GNU_SOURCE -fno-strict-aliasing -Wall -Wextra \
          -Wstrict-prototypes -Wmissing-prototypes -Wmissing-declarations \
          -Wdeclaration-after-statement -Wno-missing-field-initializers \
          -Wno-unused-parameter
CPPFLAGS ?=
INCLUDES = -Incrx

debug debug32: CFLAGS += -O0 -gdwarf-4 -fno-omit-frame-pointer \
	                 -fstack-protector-all -fsanitize=address \
                         -fsanitize=undefined
debug debug32: LDFLAGS ?= -lasan -lubsan

32bit: CFLAGS += -m32
32bit: LDFLAGS ?= -m32

disasm: CFLAGS += -fverbose-asm

binary = netconsd
lib = ncrx/libncrx.o
liball = libnetconsd.a
obj = threads.o listener.o worker.o output.o main.o
rlibobj = threads.o listener.o worker.o output.o
asm = $(obj:.o=.s)

all: $(binary) mods
rlib: $(liball)
32bit: $(binary) mods

debug: all
debug32: 32bit
disasm: $(asm)

-include $(obj:.o=.d)

$(binary): $(lib) $(obj)
	$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) $(lib) $(obj) $(LIBS) -o $@

$(liball): $(rlibobj) $(lib)
	ar rc $@ $(rlibobj) $(lib)

%.o: %.c
	$(CC) $< $(CPPFLAGS) $(CFLAGS) $(INCLUDES) -c -o $@
	$(CC) -MM $< $(INCLUDES) > $(@:.o=.d)

%.s: %.c
	$(CC) $< $(CPPFLAGS) $(CFLAGS) $(INCLUDES) -c -S -o $@

$(lib):
	$(MAKE) -e -C ncrx

mods:
	$(MAKE) -e -C modules

utils:
	$(MAKE) -e -C util

clean:
	rm -f netconsd *.o *.d *.s
	rm -f modules/*.o modules/*.so
	rm -f ncrx/*.o ncrx/*.d
	rm -f util/netconsblaster
	rm -f libnetconsd.a

=== modules/Makefile ===
CC ?= gcc
CXX ?= g++
CPPFLAGS ?=
LDFLAGS ?=

override CFLAGS += -fPIC
override CXXFLAGS += -std=c++11 -fPIC
override LDFLAGS += -shared -static-libstdc++ -static-libgcc
INCLUDES = -I../ncrx -I../include

mods = printer.so logger.so

all: $(mods)

%.so: %.c
	$(CC) $< $(CPPFLAGS) $(CFLAGS) $(INCLUDES) $(LDFLAGS) -c -o $(<:.c=.o)
	$(CC) $(<:.c=.o) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) -o $@

%.so: %.cc
	$(CXX) $< $(CPPFLAGS) $(CXXFLAGS) $(INCLUDES) $(LDFLAGS) -c -o $(<:.cc=.o)
	$(CXX) $(<:.cc=.o) $(CPPFLAGS) $(CXXFLAGS) $(LDFLAGS) -o $@

clean:
	rm -f *.o *.so

=== ncrx/Makefile ===
CC ?= gcc

CFLAGS ?= -O2 -fPIC
CFLAGS += -D_GNU_SOURCE -fno-strict-aliasing -Wall -Wextra \
          -Wstrict-prototypes -Wmissing-prototypes -Wmissing-declarations \
          -Wdeclaration-after-statement -Wno-missing-field-initializers \
          -Wno-unused-function -Wno-unused-parameter
CPPFLAGS ?=

obj = libncrx.o

all: $(obj)

%.o: %.c
	$(CC) $< $(CPPFLAGS) $(CFLAGS) $(INCLUDES) -c -o $@

clean:
	rm -f *.o

=== util/Makefile ===
CFLAGS ?= -O2 -fPIC
CFLAGS += -D_GNU_SOURCE
CPPFLAGS ?=
LDFLAGS ?=
LIBS = -lpthread

all: netconsblaster

netconsblaster:
	$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) netconsblaster.c $(LIBS) -o netconsblaster

clean:
	rm -f netconsblaster

=== debian/changelog ===
netconsd (0.4.1-1) unstable; urgency=medium

  * New upstream version 0.4.1
  * Remove upstreamed patch
  * Update copyright
  * Fix package name in debian/watch

 -- Michel Lind <michel@michel-slm.name>  Wed, 24 Apr 2024 14:10:44 -0500

netconsd (0.4-1) unstable; urgency=medium

  * Initial release. (Closes: #1065462)

 -- Michel Lind <michel@michel-slm.name>  Tue, 05 Mar 2024 11:37:50 -0600

=== debian/control ===
Source: netconsd
Section: admin
Priority: optional
Maintainer: Michel Lind <michel@michel-slm.name>
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
Standards-Version: 4.6.2
Homepage: https://facebookmicrosites.github.io/netconsd
Vcs-Browser: https://salsa.debian.org/michel/netconsd
Vcs-Git: https://salsa.debian.org/michel/netconsd.git

Package: netconsd
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Description: Netconsole Daemon
 This is a daemon for receiving and processing logs from the Linux Kernel, as
 emitted over a network by the kernel's netconsole module. It supports both the
 old "legacy" text-only format, and the new extended format added in v4.4.	
 .
 The core of the daemon does nothing but process messages and drop them: in
 order to make the daemon useful, the user must supply one or more "output
 modules". These modules are shared object files which expose a small ABI that
 is called by netconsd with the content and metadata for netconsole messages it
 receives.

=== debian/rules ===
#!/usr/bin/make -f

# See debhelper(7) (uncomment to enable).
# Output every command that modifies files on the build system.
#export DH_VERBOSE = 1


# See FEATURE AREAS in dpkg-buildflags(1).
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_build:
	# do binary only from the main Makefile
	# if it builds util and modules it seems that
	# environment variables are not respected
	# dh_auto_build -- all utils
	dh_auto_build -- netconsd
	dh_auto_build -- -C modules
	dh_auto_build -- -C util

=== debian/watch ===
# run the "uscan" command to check for upstream updates and more.
# See uscan(1) for format.

# Compulsory line, this is a version 4 file.
version=4

opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%netconsd-$1.tar.gz%" \
   https://github.com/facebook/netconsd/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
